// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: solarmodule/solarmodule.proto

package openfmb.solarmodule;

/**
 * <pre>
 * Solar event
 * </pre>
 *
 * Protobuf type {@code solarmodule.SolarEvent}
 */
public final class SolarEvent extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:solarmodule.SolarEvent)
    SolarEventOrBuilder {
private static final long serialVersionUID = 0L;
  // Use SolarEvent.newBuilder() to construct.
  private SolarEvent(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private SolarEvent() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new SolarEvent();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarEvent_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarEvent_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.solarmodule.SolarEvent.class, openfmb.solarmodule.SolarEvent.Builder.class);
  }

  public static final int EVENTVALUE_FIELD_NUMBER = 1;
  private openfmb.commonmodule.EventValue eventValue_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.EventValue eventValue = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the eventValue field is set.
   */
  @java.lang.Override
  public boolean hasEventValue() {
    return eventValue_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.EventValue eventValue = 1 [(.uml.option_parent_message) = true];</code>
   * @return The eventValue.
   */
  @java.lang.Override
  public openfmb.commonmodule.EventValue getEventValue() {
    return eventValue_ == null ? openfmb.commonmodule.EventValue.getDefaultInstance() : eventValue_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.EventValue eventValue = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.EventValueOrBuilder getEventValueOrBuilder() {
    return eventValue_ == null ? openfmb.commonmodule.EventValue.getDefaultInstance() : eventValue_;
  }

  public static final int SOLAREVENTZGEN_FIELD_NUMBER = 2;
  private openfmb.solarmodule.SolarEventZGEN solarEventZGEN_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarEventZGEN solarEventZGEN = 2;</code>
   * @return Whether the solarEventZGEN field is set.
   */
  @java.lang.Override
  public boolean hasSolarEventZGEN() {
    return solarEventZGEN_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarEventZGEN solarEventZGEN = 2;</code>
   * @return The solarEventZGEN.
   */
  @java.lang.Override
  public openfmb.solarmodule.SolarEventZGEN getSolarEventZGEN() {
    return solarEventZGEN_ == null ? openfmb.solarmodule.SolarEventZGEN.getDefaultInstance() : solarEventZGEN_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarEventZGEN solarEventZGEN = 2;</code>
   */
  @java.lang.Override
  public openfmb.solarmodule.SolarEventZGENOrBuilder getSolarEventZGENOrBuilder() {
    return solarEventZGEN_ == null ? openfmb.solarmodule.SolarEventZGEN.getDefaultInstance() : solarEventZGEN_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (eventValue_ != null) {
      output.writeMessage(1, getEventValue());
    }
    if (solarEventZGEN_ != null) {
      output.writeMessage(2, getSolarEventZGEN());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (eventValue_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getEventValue());
    }
    if (solarEventZGEN_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getSolarEventZGEN());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.solarmodule.SolarEvent)) {
      return super.equals(obj);
    }
    openfmb.solarmodule.SolarEvent other = (openfmb.solarmodule.SolarEvent) obj;

    if (hasEventValue() != other.hasEventValue()) return false;
    if (hasEventValue()) {
      if (!getEventValue()
          .equals(other.getEventValue())) return false;
    }
    if (hasSolarEventZGEN() != other.hasSolarEventZGEN()) return false;
    if (hasSolarEventZGEN()) {
      if (!getSolarEventZGEN()
          .equals(other.getSolarEventZGEN())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasEventValue()) {
      hash = (37 * hash) + EVENTVALUE_FIELD_NUMBER;
      hash = (53 * hash) + getEventValue().hashCode();
    }
    if (hasSolarEventZGEN()) {
      hash = (37 * hash) + SOLAREVENTZGEN_FIELD_NUMBER;
      hash = (53 * hash) + getSolarEventZGEN().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.solarmodule.SolarEvent parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarEvent parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarEvent parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarEvent parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarEvent parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarEvent parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarEvent parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarEvent parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarEvent parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarEvent parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarEvent parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarEvent parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.solarmodule.SolarEvent prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Solar event
   * </pre>
   *
   * Protobuf type {@code solarmodule.SolarEvent}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:solarmodule.SolarEvent)
      openfmb.solarmodule.SolarEventOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarEvent_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarEvent_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.solarmodule.SolarEvent.class, openfmb.solarmodule.SolarEvent.Builder.class);
    }

    // Construct using openfmb.solarmodule.SolarEvent.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      eventValue_ = null;
      if (eventValueBuilder_ != null) {
        eventValueBuilder_.dispose();
        eventValueBuilder_ = null;
      }
      solarEventZGEN_ = null;
      if (solarEventZGENBuilder_ != null) {
        solarEventZGENBuilder_.dispose();
        solarEventZGENBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarEvent_descriptor;
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarEvent getDefaultInstanceForType() {
      return openfmb.solarmodule.SolarEvent.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarEvent build() {
      openfmb.solarmodule.SolarEvent result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarEvent buildPartial() {
      openfmb.solarmodule.SolarEvent result = new openfmb.solarmodule.SolarEvent(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.solarmodule.SolarEvent result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.eventValue_ = eventValueBuilder_ == null
            ? eventValue_
            : eventValueBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.solarEventZGEN_ = solarEventZGENBuilder_ == null
            ? solarEventZGEN_
            : solarEventZGENBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.solarmodule.SolarEvent) {
        return mergeFrom((openfmb.solarmodule.SolarEvent)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.solarmodule.SolarEvent other) {
      if (other == openfmb.solarmodule.SolarEvent.getDefaultInstance()) return this;
      if (other.hasEventValue()) {
        mergeEventValue(other.getEventValue());
      }
      if (other.hasSolarEventZGEN()) {
        mergeSolarEventZGEN(other.getSolarEventZGEN());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getEventValueFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getSolarEventZGENFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.EventValue eventValue_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.EventValue, openfmb.commonmodule.EventValue.Builder, openfmb.commonmodule.EventValueOrBuilder> eventValueBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.EventValue eventValue = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the eventValue field is set.
     */
    public boolean hasEventValue() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.EventValue eventValue = 1 [(.uml.option_parent_message) = true];</code>
     * @return The eventValue.
     */
    public openfmb.commonmodule.EventValue getEventValue() {
      if (eventValueBuilder_ == null) {
        return eventValue_ == null ? openfmb.commonmodule.EventValue.getDefaultInstance() : eventValue_;
      } else {
        return eventValueBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.EventValue eventValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setEventValue(openfmb.commonmodule.EventValue value) {
      if (eventValueBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        eventValue_ = value;
      } else {
        eventValueBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.EventValue eventValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setEventValue(
        openfmb.commonmodule.EventValue.Builder builderForValue) {
      if (eventValueBuilder_ == null) {
        eventValue_ = builderForValue.build();
      } else {
        eventValueBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.EventValue eventValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeEventValue(openfmb.commonmodule.EventValue value) {
      if (eventValueBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          eventValue_ != null &&
          eventValue_ != openfmb.commonmodule.EventValue.getDefaultInstance()) {
          getEventValueBuilder().mergeFrom(value);
        } else {
          eventValue_ = value;
        }
      } else {
        eventValueBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.EventValue eventValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearEventValue() {
      bitField0_ = (bitField0_ & ~0x00000001);
      eventValue_ = null;
      if (eventValueBuilder_ != null) {
        eventValueBuilder_.dispose();
        eventValueBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.EventValue eventValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.EventValue.Builder getEventValueBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getEventValueFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.EventValue eventValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.EventValueOrBuilder getEventValueOrBuilder() {
      if (eventValueBuilder_ != null) {
        return eventValueBuilder_.getMessageOrBuilder();
      } else {
        return eventValue_ == null ?
            openfmb.commonmodule.EventValue.getDefaultInstance() : eventValue_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.EventValue eventValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.EventValue, openfmb.commonmodule.EventValue.Builder, openfmb.commonmodule.EventValueOrBuilder> 
        getEventValueFieldBuilder() {
      if (eventValueBuilder_ == null) {
        eventValueBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.EventValue, openfmb.commonmodule.EventValue.Builder, openfmb.commonmodule.EventValueOrBuilder>(
                getEventValue(),
                getParentForChildren(),
                isClean());
        eventValue_ = null;
      }
      return eventValueBuilder_;
    }

    private openfmb.solarmodule.SolarEventZGEN solarEventZGEN_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.solarmodule.SolarEventZGEN, openfmb.solarmodule.SolarEventZGEN.Builder, openfmb.solarmodule.SolarEventZGENOrBuilder> solarEventZGENBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarEventZGEN solarEventZGEN = 2;</code>
     * @return Whether the solarEventZGEN field is set.
     */
    public boolean hasSolarEventZGEN() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarEventZGEN solarEventZGEN = 2;</code>
     * @return The solarEventZGEN.
     */
    public openfmb.solarmodule.SolarEventZGEN getSolarEventZGEN() {
      if (solarEventZGENBuilder_ == null) {
        return solarEventZGEN_ == null ? openfmb.solarmodule.SolarEventZGEN.getDefaultInstance() : solarEventZGEN_;
      } else {
        return solarEventZGENBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarEventZGEN solarEventZGEN = 2;</code>
     */
    public Builder setSolarEventZGEN(openfmb.solarmodule.SolarEventZGEN value) {
      if (solarEventZGENBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        solarEventZGEN_ = value;
      } else {
        solarEventZGENBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarEventZGEN solarEventZGEN = 2;</code>
     */
    public Builder setSolarEventZGEN(
        openfmb.solarmodule.SolarEventZGEN.Builder builderForValue) {
      if (solarEventZGENBuilder_ == null) {
        solarEventZGEN_ = builderForValue.build();
      } else {
        solarEventZGENBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarEventZGEN solarEventZGEN = 2;</code>
     */
    public Builder mergeSolarEventZGEN(openfmb.solarmodule.SolarEventZGEN value) {
      if (solarEventZGENBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          solarEventZGEN_ != null &&
          solarEventZGEN_ != openfmb.solarmodule.SolarEventZGEN.getDefaultInstance()) {
          getSolarEventZGENBuilder().mergeFrom(value);
        } else {
          solarEventZGEN_ = value;
        }
      } else {
        solarEventZGENBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarEventZGEN solarEventZGEN = 2;</code>
     */
    public Builder clearSolarEventZGEN() {
      bitField0_ = (bitField0_ & ~0x00000002);
      solarEventZGEN_ = null;
      if (solarEventZGENBuilder_ != null) {
        solarEventZGENBuilder_.dispose();
        solarEventZGENBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarEventZGEN solarEventZGEN = 2;</code>
     */
    public openfmb.solarmodule.SolarEventZGEN.Builder getSolarEventZGENBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getSolarEventZGENFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarEventZGEN solarEventZGEN = 2;</code>
     */
    public openfmb.solarmodule.SolarEventZGENOrBuilder getSolarEventZGENOrBuilder() {
      if (solarEventZGENBuilder_ != null) {
        return solarEventZGENBuilder_.getMessageOrBuilder();
      } else {
        return solarEventZGEN_ == null ?
            openfmb.solarmodule.SolarEventZGEN.getDefaultInstance() : solarEventZGEN_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarEventZGEN solarEventZGEN = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.solarmodule.SolarEventZGEN, openfmb.solarmodule.SolarEventZGEN.Builder, openfmb.solarmodule.SolarEventZGENOrBuilder> 
        getSolarEventZGENFieldBuilder() {
      if (solarEventZGENBuilder_ == null) {
        solarEventZGENBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.solarmodule.SolarEventZGEN, openfmb.solarmodule.SolarEventZGEN.Builder, openfmb.solarmodule.SolarEventZGENOrBuilder>(
                getSolarEventZGEN(),
                getParentForChildren(),
                isClean());
        solarEventZGEN_ = null;
      }
      return solarEventZGENBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:solarmodule.SolarEvent)
  }

  // @@protoc_insertion_point(class_scope:solarmodule.SolarEvent)
  private static final openfmb.solarmodule.SolarEvent DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.solarmodule.SolarEvent();
  }

  public static openfmb.solarmodule.SolarEvent getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<SolarEvent>
      PARSER = new com.google.protobuf.AbstractParser<SolarEvent>() {
    @java.lang.Override
    public SolarEvent parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<SolarEvent> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<SolarEvent> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.solarmodule.SolarEvent getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

